//////////////////////////////////////////////////////////////////////
//  vWFNg  :  MAC2IP
//
//  t@C  :  IPAhXNXwb_[
//
//  J      :  Visual Studio 2019
//
//  @@    :  2020/ 3/14
//
//  @@    :  ElementTech  Hidetoshi Matsui
//////////////////////////////////////////////////////////////////////
#pragma once
#include  "Message.h"
#include  "NetworkNic.h"
#include  "DialogCommon.h"

//////////////////////////////////////////////////////////////////////
//        萔`
//////////////////////////////////////////////////////////////////////
const int	c_nInputLength = 17;
const int	c_nProgressMin = 0;
const int	c_nProgressMax = 255;

//////////////////////////////////////////////////////////////////////
//        NX`
//////////////////////////////////////////////////////////////////////
class	DialogMACIP : DialogCommon, NetworkNic, ErrorMessage	{
	HWND		m_hWndParent;
	HINSTANCE	m_hInstanceParent;
public:

				DialogMACIP(HINSTANCE p_hInstance, HWND p_hWnd);
				~DialogMACIP();
	BOOL		createDialogBox(HWND p_hWnd);
	BOOL		dlgProc(HWND p_hDlg, UINT p_message, WPARAM wParam, LPARAM lParam);
private:
	BOOL		dlgInit(HWND p_hDlg);
	BOOL		dlgCommand(HWND p_hDlg, WPARAM p_wParam, LPARAM p_lParam);
	VOID		dlgCommandOK(HWND p_hDlg);
	BOOL		checkString(HWND p_hDlg, LPCTSTR p_pctszMacAddress);
	BOOL		checkMacAddress(LPCTSTR p_pctszMacAddress, int p_nLength);
};
