//////////////////////////////////////////////////////////////////////
//  vWFNg  :  MAC2IP
//
//  t@C  :  lbg[N֘ANX
//
//  J      :  Visual Studio 2019
//
//  @@    :  2020/ 3/15
//
//  @@    :  ElementTech  Hidetoshi Matsui
//////////////////////////////////////////////////////////////////////
#include  <WinSock2.h>
#include  <ws2tcpip.h>
#include  <iphlpapi.h>
#include  <Windows.h>
#include  <CommCtrl.h>
#include  <Process.h>
#include  <TChar.h>
#include  "NetworkNic.h"

//////////////////////////////////////////////////////////////////////
//        Xbh
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//  ց@@   :  MACAddressToIPAddress
//
//  @@@@\   :  IPAhX̌sB
//
//  p[^   :  LPVOID  p_plParam  <- Xbĥ̃|C^
//
//  ߁@@l   :  unsigned IR[h
//
//  @@   :  2020/ 3/15   by H.m
//////////////////////////////////////////////////////////////////////
unsigned __stdcall ThreadMAC2IPW(LPVOID p_plParam)
{
	// NXCX^X擾
	PThreadInfo pInfo = (PThreadInfo)p_plParam;
	NetworkNic* pNetNic = (NetworkNic*)pInfo->queryNetworkInstace();

	// IPAhXT
	pNetNic->resolveAddress(pInfo);

	// XbhI
	_endthreadex(0);

	return 0;
}

//////////////////////////////////////////////////////////////////////
//        RXgN^/fXgN^
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//  \bh   :  NetworkNic
//
//  @@@@\   :  RXgN^
//
//  p[^   :  Ȃ
//
//  ߁@@l   :  g̃CX^X
//
//  @@   :  2020/ 3/15   by H.m
//////////////////////////////////////////////////////////////////////
NetworkNic::NetworkNic()
{
}

//////////////////////////////////////////////////////////////////////
//  \bh   :  ~NetworkNic
//
//  @@@@\   :  fXgN^
//
//  p[^   :  Ȃ
//
//  ߁@@l   :  Ȃ
//
//  @@   :  2020/ 3/15   by H.m
//////////////////////////////////////////////////////////////////////
NetworkNic::~NetworkNic()
{
}

//////////////////////////////////////////////////////////////////////
//        pubN\bh
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//  \bh   : searchIPAddress
//
//  @@@@\   :  MACAhXIPAhXB
//
//  p[^   :  LPCTSTR  p_pctszMacAddress  <- MACAhX
//                  LPTSTR   p_ptszIpAddress    -> IPAhX
//                  HWND     p_hWndProgress     <- vOXo[̃nh
//
//  ߁@@l   :  BOOL  IPAhX
//
//  @@   :  2020/ 3/18   by H.m
//////////////////////////////////////////////////////////////////////
BOOL	NetworkNic::searchIPAddress(LPCTSTR p_pctszMacAddress, LPTSTR p_ptszIpAddress, HWND p_hWndProgress)
{
	int		nSplit;
	BOOL	fResult = FALSE;

	// o[ݒ
	m_hWndProgress = p_hWndProgress;

	// \Pbg
	WSADATA	wsaData;
	int nError = WSAStartup(MAKEWORD(2, 2), &wsaData);
	if (nError == 0)	{
		// IPAhX̃ZOg𓾂
		TCHAR	tszSegment[MAX_PATH];
		if (querySegment(tszSegment))	{
			int nAddress = 0;
			// 񐔕XL
			for (nSplit = 0; nSplit < c_nSplit; nSplit++)	{
				// IPAhXXLĒT
				fResult = scanIPAddress(p_pctszMacAddress, tszSegment, p_ptszIpAddress, nAddress);
				if (fResult)	{
					break;
				}
			}
		}

		// \PbgI
		WSACleanup();
	}
	return fResult;
}

//////////////////////////////////////////////////////////////////////
//  \bh   :  scanIPAddress
//
//  @@@@\   :  w肳ꂽZOgYIPAhXTB
//
//  p[^   :  LPCTSTR  p_pctszMacAddress  <- MACAhX
//                  LPCTSTR  p_pctszSegment     <- XLIPZOg
//                  LPTSTR   p_ptszIpAddress    -> IPAhX
//                  int&     p_nAddress         <->vOXo[̈ʒu
//
//  ߁@@l   :  BOOL  IPAhX
//
//  @@   :  2020/ 3/18   by H.m
//////////////////////////////////////////////////////////////////////
BOOL	NetworkNic::scanIPAddress(LPCTSTR p_pctszMacAddress, LPCTSTR p_pctszSegment, LPTSTR p_ptszIpAddress, int& p_nAddress)
{
	int				nSelect;
	int				nCount;
	unsigned		dwThread;
	TCHAR			tszIpAddress[MAX_PATH];
	HANDLE			hThreads[c_nRange];
	PThreadInfo		pThreaInfo[c_nRange];
	BOOL			fResult = FALSE;

	// 
	int nSize = sizeof(HANDLE) * c_nRange;
	ZeroMemory(&hThreads[0], nSize);
	nSize = sizeof(PThreadInfo) * c_nRange;
	ZeroMemory(&pThreaInfo[0], nSize);

	// IPAhX̓ZOgXL
	for (nSelect = 0; nSelect < c_nRange; nSelect++)	{
		// Xbhɓn̂쐬
		wsprintf(tszIpAddress, _T("%s%d"),  p_pctszSegment, p_nAddress);
		pThreaInfo[nSelect] = new ThreadInfo(p_pctszMacAddress, tszIpAddress, p_nAddress, (LPARAM)this);
		if (pThreaInfo[nSelect] != NULL)	{
			// MACAhX𒲂ׂXbhĂяo
			hThreads[nSelect] = (HANDLE)_beginthreadex(NULL, 0, ThreadMAC2IPW, pThreaInfo[nSelect], 0, &dwThread);
		}
		// vOXo[XV
		SendMessage(m_hWndProgress, PBM_SETPOS, p_nAddress, 0);

		// AhXXV
		p_nAddress++;
		if (p_nAddress > 256)	{
			break;
		}
	}

	// SẴXbhÎ҂
	nCount = nSelect;
	WaitForMultipleObjects(nCount, hThreads, TRUE, INFINITE);

	// YMACAhXׂ
	*p_ptszIpAddress = 0;
	for (nSelect = 0; nSelect < nCount; nSelect++)	{
		if (pThreaInfo[nSelect] != NULL)	{
			if (pThreaInfo[nSelect] ->isFound())	{
				lstrcpy(p_ptszIpAddress, pThreaInfo[nSelect]->queryIPAddress());
				fResult = TRUE;
				break;
			}
		}
	}

	// NXƃXbhnhj
	for (nSelect = 0; nSelect < nCount; nSelect++)	{
		if (hThreads[nSelect] != NULL)	{
			CloseHandle(hThreads[nSelect]);
		}
		if (pThreaInfo[nSelect] != NULL)	{
			delete pThreaInfo[nSelect];
		}
	}

	return fResult;
}

//////////////////////////////////////////////////////////////////////
//  \bh   :  querySegment
//
//  @@@@\   :  w肳ꂽIPAhXZOg𓾂B
//
//  p[^   :  LPTSTR  p_ptszSegment  -> ZOgIP
//
//  ߁@@l   :  BOOL
//
//  @@   :  2020/ 3/15   by H.m
//////////////////////////////////////////////////////////////////////
BOOL	NetworkNic::querySegment(LPTSTR p_ptszSegment)
{
	// gpIPAhX擾
	TCHAR	tszCurrentIP[MAX_PATH];
	if (!getCurrentIP(tszCurrentIP))	{
		return FALSE;
	}
	// ZOg𓾂
	if (!getSegment(tszCurrentIP, p_ptszSegment))	{
		return FALSE;
	}
	return TRUE;
}

//////////////////////////////////////////////////////////////////////
//  \bh   :  getCurrentIP
//
//  @@@@\   :  @IPAhX擾B
//
//  p[^   :  LPTSTR  p_ptszCurentIP  -> @IPAhX
//
//  ߁@@l   :  BOOL
//
//  @@   :  2020/ 3/15   by H.m
//////////////////////////////////////////////////////////////////////
BOOL	NetworkNic::getCurrentIP(LPTSTR p_ptszCurentIP)
{
	CHAR			szHostName[MAX_PATH];
	struct hostent*	host;
	BOOL			fResult = FALSE;

	// 
	*p_ptszCurentIP = 0;

	// @̃lbg[N𒲂ׂ
	gethostname(szHostName, sizeof(szHostName));
	host = gethostbyname(szHostName);						// IP v4 ̂ݑΉ̂

	// @IPAhX𒲂ׂ
	if (host != NULL)	{
		TCHAR	tszIPAddress[MAX_PATH];
		ZeroMemory(tszIPAddress, sizeof(tszIPAddress));
		int		nSel;
		// IPAhX𐶐
		for (nSel = 0; host->h_addr_list[nSel]; nSel++)	{
			wsprintf(tszIPAddress, _T("%d.%d.%d.%d"),
				(BYTE)*((host->h_addr_list[nSel])),
				(BYTE)*((host->h_addr_list[nSel]) + 1),
				(BYTE)*((host->h_addr_list[nSel]) + 2) ,
				(BYTE)*((host->h_addr_list[nSel]) + 3));

		}
		lstrcpy(p_ptszCurentIP, tszIPAddress);
		fResult = TRUE;
	}
	return fResult;
}

//////////////////////////////////////////////////////////////////////
//  \bh   :  getSegment
//
//  @@@@\   :  w肳ꂽIPAhXZOg𓾂B
//
//  p[^   :  LPCTSTR  p_pctszIPAddress  <- IPAhX
//                  LPTSTR   p_tszSegment      -> ZOgIP
//
//  ߁@@l   :  BOOL
//
//  @@   :  2020/ 3/15   by H.m
//////////////////////////////////////////////////////////////////////
BOOL	NetworkNic::getSegment(LPCTSTR p_pctszIPAddress, LPTSTR p_ptszSegment)
{
	int			nSel;
	int			nCount;
	int			nLength;

	// IPAhX󂾂G[
	nLength = lstrlen(p_pctszIPAddress);
	if (nLength == 0)	{
		return FALSE;
	}

	// IPAhXȂ΃G[
	nCount = 0;
	for (nSel = 0; nSel < nLength; nSel++)	{
		if (*(p_pctszIPAddress + nSel) == '.')	nCount++;
	}
	if (nCount != 3)	{
		return FALSE;
	}

	// ZOgԂ
	for (nSel = nLength - 1; nSel > 0; nSel--)	{
		if (*(p_pctszIPAddress + nSel) == '.')	break;
	}
	lstrcpyn(p_ptszSegment, p_pctszIPAddress, nSel + 2);

	return TRUE;
}

//////////////////////////////////////////////////////////////////////
//  \bh   :  resolveAddress
//
//  @@@@\   :  w肳ꂽIPAhX(IPv4)MACAhX擾Ĉv邩ׂB
//
//  p[^   :  PThreadInfo  p_pThreadInfo  <-> Xbh
//
//  ߁@@l   :  BOOL  IPAhX
//
//  @@   :  2020/ 3/18   by H.m
//////////////////////////////////////////////////////////////////////
BOOL	NetworkNic::resolveAddress(PThreadInfo p_pThreadInfo)
{
	CHAR	szIPAddress[MAX_PATH];
	TCHAR	tszMacAddress[MAX_PATH];

	// 
	ZeroMemory(tszMacAddress, sizeof(tszMacAddress));

	// ANSIɕϊ
	if (p_pThreadInfo == NULL)	{
		return FALSE;
	}
	WideCharToMultiByte(CP_ACP, 0, p_pThreadInfo->queryIPAddress(), -1, szIPAddress, _countof(szIPAddress), NULL, NULL);

	// IPAhXϊ
	IPAddr IPAddress = inet_addr(szIPAddress);						// IP v4 ̂ݑΉ̂

	// ARPR}h𔭍sMACAhX擾
	MACADDR	macAddress;
	ULONG ulLen = sizeof(MACADDR);
	ZeroMemory(&macAddress, sizeof(MACADDR));
	DWORD dwResult = SendARP(IPAddress, NULL, (PULONG)&macAddress, &ulLen);
	if (dwResult != NO_ERROR) {
		p_pThreadInfo->setNic(FALSE);
		return FALSE;
	}

	// MACAhX𕶎񐶐
	wsprintf(tszMacAddress, _T("%02X:%02X:%02X:%02X:%02X:%02X"), macAddress.m_bAddress1, macAddress.m_bAddress2, macAddress.m_bAddress3, macAddress.m_bAddress4, macAddress.m_bAddress5, macAddress.m_bAddress6);

	// w肳ꂽMACAhXƔr
	if (lstrcmpi(p_pThreadInfo->queryMACAddress(), tszMacAddress) == 0)	{
		p_pThreadInfo->setFound();
	}
	return TRUE;
}

